package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.SysPlanInfoDTO;
import com.diagbot.dto.SysSetInfoDTO;
import com.diagbot.entity.SysPlan;
import com.diagbot.entity.SysSet;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.enums.StatusEnum;
import com.diagbot.enums.SysTypeEnum;
import com.diagbot.service.impl.SysPlanServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.HospitalPlanVO;
import com.diagbot.vo.HospitalSetVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author wangfeng
 * @Description:
 * @date 2020-07-27 19:23
 */
@Component
public class SysPlanFacade extends SysPlanServiceImpl {

    @Autowired
    SysSetFacade sysSetFacade;

    public SysPlanInfoDTO getSysPlanInfoData(HospitalPlanVO hospitalPlanVO) {
        //查询该医院有没有相关方案配置， 要是没有取默认的
        SysPlanInfoDTO sysPlanInfoDTO = new SysPlanInfoDTO();
        QueryWrapper<SysPlan> sysPlanInfo = new QueryWrapper<>();
        sysPlanInfo.eq("is_deleted", IsDeleteEnum.N.getKey());
        sysPlanInfo.eq("hospital_id", hospitalPlanVO.getHospitalId());
        sysPlanInfo.eq(StringUtil.isNotBlank(hospitalPlanVO.getPlanCode()), "plan_code", hospitalPlanVO.getPlanCode());
        sysPlanInfo.eq("plan_status", StatusEnum.Enable.getKey());
        SysPlan sysPlanInfoData = getOne(sysPlanInfo, false);
        Long planId = -1L;
        Long hospitalId = hospitalPlanVO.getHospitalId();
        if (sysPlanInfoData != null) {
            BeanUtil.copyProperties(sysPlanInfoData, sysPlanInfoDTO);
            planId = sysPlanInfoDTO.getId();
        } else {
            QueryWrapper<SysPlan> sysPlandefault = new QueryWrapper<>();
            sysPlandefault.eq("is_deleted", IsDeleteEnum.N.getKey());
            sysPlandefault.eq("hospital_id", -1);
            sysPlandefault.eq(StringUtil.isNotBlank(hospitalPlanVO.getPlanCode()), "plan_code", hospitalPlanVO.getPlanCode());
            sysPlandefault.eq("plan_status", StatusEnum.Enable.getKey());
            SysPlan sysPlandefaultData = getOne(sysPlandefault, false);
            if (sysPlandefaultData != null) {
                planId = sysPlandefaultData.getId();
                hospitalId = sysPlandefaultData.getHospitalId();
                BeanUtil.copyProperties(sysPlandefaultData, sysPlanInfoDTO);
            }
        }
        HospitalSetVO hospitalSetVO = new HospitalSetVO();
        hospitalSetVO.setHospitalId(hospitalId);
        hospitalSetVO.setPlanId(planId);
        List<SysSetInfoDTO> sysSetInfoData = sysSetFacade.getSysSetInfoData(hospitalSetVO);
        sysPlanInfoDTO.setSysSetInfo(sysSetInfoData);
        return sysPlanInfoDTO;
    }
}
