package com.diagbot.facade;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.diagbot.dto.SysSetInfoDTO;
import com.diagbot.entity.SysPlan;
import com.diagbot.entity.SysSet;
import com.diagbot.enums.IsDeleteEnum;
import com.diagbot.enums.StatusEnum;
import com.diagbot.enums.SysTypeEnum;
import com.diagbot.service.impl.SysSetServiceImpl;
import com.diagbot.util.BeanUtil;
import com.diagbot.util.StringUtil;
import com.diagbot.vo.HospitalSetVO;
import org.springframework.stereotype.Component;

import java.util.List;

/**
 * @author wangfeng
 * @Description:
 * @date 2020-07-27 19:01
 */
@Component
public class SysSetFacade extends SysSetServiceImpl {


    public List<SysSetInfoDTO> getSysSetInfoData(HospitalSetVO hospitalSetVO) {
        QueryWrapper<SysSet> sysSetInfo = new QueryWrapper<>();
        sysSetInfo.eq("is_deleted", IsDeleteEnum.N.getKey());
        sysSetInfo.eq("hospital_id", hospitalSetVO.getHospitalId());
        sysSetInfo.eq("plan_id", hospitalSetVO.getPlanId());
        sysSetInfo.eq(StringUtil.isNotBlank(hospitalSetVO.getCode()),"code",hospitalSetVO.getCode());
        List<SysSet> sysSetData = list(sysSetInfo);
        List<SysSetInfoDTO> data = BeanUtil.listCopyTo(sysSetData, SysSetInfoDTO.class);
        return data;
    }
}
