package com.diagbot.web;


import com.diagbot.annotation.SysLogger;
import com.diagbot.dto.RespDTO;
import com.diagbot.dto.SysPlanInfoDTO;
import com.diagbot.dto.SysSetInfoDTO;
import com.diagbot.facade.SysPlanFacade;
import com.diagbot.facade.SysSetFacade;
import com.diagbot.vo.HospitalPlanVO;
import com.diagbot.vo.HospitalSetVO;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;

import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.RestController;

import javax.validation.Valid;
import java.util.List;

/**
 * <p>
 *  前端控制器
 * </p>
 *
 * @author wangfeng
 * @since 2020-07-27
 */
@RestController
@RequestMapping("/sys/sysPlan")
@Api(value = "方案配置信息API", tags = { "方案配置信息API" })
@SuppressWarnings("unchecked")
public class SysPlanController {
    @Autowired
    SysPlanFacade sysPlanFacade;


    @ApiOperation(value = "根据医院获取方案配置信息[by:wangfeng]", notes = "hospitalid ：医院id  必填<br> ")
    @PostMapping("/getSysPlanInfoDatas")
    @SysLogger("getSysPlanInfoDatas")
    public RespDTO<SysPlanInfoDTO> getSysPlanInfoDatas(@Valid @RequestBody HospitalPlanVO hospitalPlanVO) {
        SysPlanInfoDTO data = sysPlanFacade.getSysPlanInfoData(hospitalPlanVO);
        return RespDTO.onSuc(data);
    }
}
